/***************************************************************************
  FILE: RegParam.java, TomaszMajor-10May99
  PURPOSE: raeding and storage for registration params
  $Id: RegParam.java,v 1.5 1999/09/08 16:14:05 toma Exp $
  Component: Plugin, Interfaces
***************************************************************************/


package webwisdom.tango;


import java.util.StringTokenizer;

import netscape.javascript.JSObject;


/**Raeds and stores registration parameters.*/
public class RegParam
{
    private static String CL="RegParam";


    public boolean inf=false;
    public String pre=null;
    public int aid=-1,sid=-1,at=-1;
    public int port=-1;


    //for TLAgentApplet

    public RegParam(String prep,int aidp,int sidp,int atp)
      throws TangoException
    {
      System.out.println(CL+".RegParam("+prep+","+aidp+","+sidp+","+atp+")");

      pre=prep;
      inf=(pre!=null);
      aid=aidp;
      sid=sidp;
      at=atp;
    }// RegParam ___________________________________________________________


    private void init(String regStr) throws TangoException
    {
      //System.out.println(CL+".init("+regStr+")");

      if(regStr==null)
	throw new TangoException(CL+": null reg string");
      if(regStr.length()<"winX_X_X_X".length())
	throw new TangoException(CL+": corrupted reg string: \'"+regStr+"\'");
      try
      {
	StringTokenizer st=new StringTokenizer(regStr.substring(3),"_");
	aid=Integer.valueOf(st.nextToken()).intValue();
	sid=Integer.valueOf(st.nextToken()).intValue();
	at=Integer.valueOf(st.nextToken()).intValue();
	inf=st.hasMoreTokens();
	pre=inf?regStr:null;

	System.out.println(CL+".init(): aid="+aid+",sid="+sid+",at="+at+",inf="+inf+",pre="+pre);
      }
      catch(NumberFormatException e)
      {
	//e.printStackTrace();
	throw new TangoException(CL+": corrupted reg string: "+e.getMessage());
      }
    }// RegParam ___________________________________________________________


    public RegParam(String regStr) throws TangoException
    {
      //System.out.println(CL+".RegParam("+regStr+")");

      init(regStr);
    }// RegParam ___________________________________________________________


    public RegParam(JSObject win) throws TangoException
    {
      //System.out.println(CL+".RegParam("+win+")");

      try
      {
	netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserAccess");
      
	JSObject top=(JSObject)win.getMember("top");
	String winName=(String)win.getMember("name");	
	String topName=(String)top.getMember("name");	

	String regStr;
	if(topName.startsWith("win"))
	  regStr=topName;
	else if(winName.startsWith("win"))
	  regStr=winName;
	else
	  throw new TangoException(CL+": reg string not found in window name: \'"+topName+"\',\'"+winName+"\'");
	//System.out.println(CL+".RegParam(): winName="+winName+",topName="+topName+",regStr="+regStr);

	init(regStr);
      }
      catch(UnsatisfiedLinkError e)
      {
	//e.printStackTrace();
	throw new TangoException(CL+": missing library: "+e.getMessage());
      }
      catch(NoClassDefFoundError e)
      {
	//e.printStackTrace();
	throw new TangoException(CL+": missing classes: "+e.getMessage());
      }
    }// RegParam ___________________________________________________________


    //for TLAgentApplication

    //public static String PARAM_AGENTTYPE="tango.agentType";
    //public static String PARAM_FAKESERVER="tango.fakeServer";
    public static String PARAM_REGPARAMS="tango.regParams";


    public RegParam(int aidp,int sidp,int atp,int portp)
      throws TangoException
    {
      //System.out.println(CL+".RegParam("+aidp+","+sidp+","+atp+","+portp+")");

      aid=aidp;
      sid=sidp;
      at=atp;
      port=portp;
    }// RegParam ___________________________________________________________


    public RegParam(String[] args)
      throws TangoException
    {
      //System.out.println(CL+".RegParam("+arrayToString(args)+")");

      String param=getParameter(args,PARAM_REGPARAMS);
      if(param==null)
        throw new TangoException("missing parameter: "+PARAM_REGPARAMS);

      try
      {
	StringTokenizer st=new StringTokenizer(param,":");

	aid=Integer.valueOf(st.nextToken()).intValue();
	sid=Integer.valueOf(st.nextToken()).intValue();
	at=Integer.valueOf(st.nextToken()).intValue();
	port=Integer.valueOf(st.nextToken()).intValue();

	//System.out.println(CL+".RegParam(): aid="+aid+",sid="+sid+",at="+at+",port="+port);
      }
      catch(NumberFormatException e)
      {
	throw new TangoException("format error: "+param);
      }
    }// RegParam ___________________________________________________________


    //utility functions

    /**Returns value of the named parameter.<br>
       Parameters are assumed to be in the following format:
       <blockquote><tt>
       [<b>-</b>&#060<i>paramName</i>&#062 &#060<i>paramValue</i>&#062]...
       </tt></blockquote>
       for example:
       <blockquote><tt>
       "-length 34 -width 68"
       </tt></blockquote>
       *@param args strings to search
       *@param name parameter name (withaut initial dash)
       *@return parameter value
       *@see java.applet.Applet#getParameter*/
    private static String getParameter(String[] args,String name)
    {
      name="-".concat(name);
      //System.out.println(CL+".getParameter(): name="+name);
      for(int i=0;i<(args.length-1);i++)
      {
	if(args[i].equals(name))
	  return args[i+1];
      }
      return null;
    }// getParameter _______________________________________________________


    private static String arrayToString(Object[] ss,
					String beg,String sep,String end)
    {
      int n;
      if(ss!=null)
	n=ss.length;
      else
	n=6;
      StringBuffer s=new StringBuffer(n*10);


      if(beg!=null)
	s.append(beg);

      if(ss!=null)
      {
	for(int i=0;i<n;i++)
	{
	  s.append(ss[i].toString());
	  if(i<(n-1))
	    s.append(sep);
	}
      }

      if(end!=null)
	s.append(end);


      return s.toString();
    }// arrayToString ______________________________________________________


    private static String arrayToString(Object[] s)
    {
      return arrayToString(s,"{",",","}");
    }// arrayToString ______________________________________________________


    public String toString()
    {
      return CL+"["+pre+","+aid+":"+sid+":"+at+","+port+"]";
    }// toString ___________________________________________________________


}// RegParam ///////////////////////////////////////////////////////////////


