/***************************************************************************
  FILE: TParticipantsListener.java, TomaszMajor-20Jun99
  PURPOSE: interface-to-app
  $Id: TParticipantsListener.java,v 1.1 1999/07/26 17:01:02 toma Exp $
  Component: Plugin, Interfaces
***************************************************************************/


package webwisdom.tango;


/**Interface for notifications from Tango runtime to applications.
   The interface informs about changes of session participants.
   *@see TAgent#addTParticipantsListener*/
public interface TParticipantsListener
{


    /**Called when a Tango user joins this session.
     *@see TAgent#getParticipantsNames*/
    public void participantJoined(String name);


    /**Called when a participant of this session leaves this session.
     *@see TAgent#getParticipantsNames*/
    public void participantLeft(String name);


}// TParticipantsListener //////////////////////////////////////////////////

