//=============================================================================
//
// class ExtensionFileFilter
//
// Author:			Grzegorz Lewandowski
// Created:			12/11/98
//
// Modified:		07/20/99
// By:				Hyun Kim
// Changes:			code reuse(no change)
//
//=============================================================================

package webwisdom.tango.config;

import com.sun.java.swing.*;
import com.sun.java.swing.preview.filechooser.*;

public class ExtensionFileFilter extends FileFilter
{
	private java.util.Vector extensions;
	private String description;

	public ExtensionFileFilter( String extension, String description )
	{
		extensions = new java.util.Vector();
		extensions.addElement( extension );
		this.description = description;
}

	public ExtensionFileFilter( String[] extensions, String description )
	{
		this.extensions = new java.util.Vector();
		for( int i = 0; i < extensions.length; i++ )
		{
			this.extensions.addElement( extensions[ i ] );
		}

		this.description = description;
	}

	public boolean accept( java.io.File f )
	{
		// System.out.print( "checking file " + f.getName() + "..." );
		if( f.isDirectory() )
		{
			// System.out.println( " ACCEPTED" );
			return true;
		}
		String fileName = f.getName();
		for( int i = 0; i < extensions.size(); i++ )
		{
			if( fileName.endsWith( (String)extensions.elementAt( i ) ) )
			{
				// System.out.println( " ACCEPTED" );
				return true;
			}
		}
		// System.out.println( " REJECTED" );
		return false;
	}

	public String getDescription()
	{
		return description;
	}
}
