//=============================================================================
//
// class ModuleFactory
//
// Created:	       	07/20/99
// Author:			Hyun Kim
// Description:     construct an instance of the class depending on the specific protocol 
//
//=============================================================================

package webwisdom.tango.config;

import java.io.*;
import java.util.*;

public class ModuleFactory {

	public static dataAccess createModule(String protocol) {

		dataAccess result = null;


		if (protocol.equals("file")) {

			result = new fileModule();
	
		} else if (protocol.equals("web")) {

			result = new httpModule();

		} else if (protocol.equals("jdbc")) {

			result = new jdbcModule();

		} else {

			try {

				throw new ProtocolNotSupportedException(protocol);

			} catch (Exception e) {

				e.printStackTrace();
				System.exit(0);
			}
		}

		return result;
	}
}

