/*
File: PasswdManager.java
Component: Server
Date		Author		Changes
Nov 30 98	Lukasz Beca	Created
Jul 27 99   Hyun Kim    Modified
*/

//package webwisdom.tango.server;
package webwisdom.tango.config;

import java.io.*;
import java.util.*;
import java.security.*;
//import webwisdom.tango.test.Log;

public class Password {
      
/*  
  
  public static boolean passwordOK(String decPasswd, String encPasswd) 
  
  : Checks if the password is valid. Password should be provided in decoded form 
    e.g. "hammer" or "elephant" and in encoded form 
    e.g. "-17.-75.-88.98.-80.101.-98.52.76.91.-111.14.120.69.-22.-68.15.104.59.125"
    Returns 'true' if the password is valid, 'false' otherwise. 

    Special case: it is possible to assign empty ("") password. 
    
*/   
  
  public static boolean passwordOK(String decPasswd, String encPasswd) {
  
      boolean result = false;	    
      String newEncPasswd;
		                                   
      if (decPasswd == null || encPasswd == null) {
      
	       return false;
	    } 
           
      if (decPasswd.length() == 0 && encPasswd.length() == 0) {
      
	      result = true;
	      
      } else {
      
          newEncPasswd = PasswdManager.getEncPasswd(decPasswd);
	      result = encPasswd.equals(newEncPasswd);
      }                   
      
      return result;      
  }
  
    
/*

  public static String getEncPasswd(String decPasswd) 
  
  : Encrypts password

*/

  
  public static String getEncPasswd(String decPasswd) {           
         
     String encPasswd;
     StringBuffer tmpPasswd = new StringBuffer();
     byte[] table = null;
     int i;
     MessageDigest md = null;

     try { 
       
	   md = MessageDigest.getInstance("SHA");      	       	    
	      
	 } catch(Exception e) {
	    
	   e.printStackTrace();
	 } 
     
     if (md != null) {
        
       md.update(decPasswd.getBytes());                     
       table = md.digest();
     }
     
     for (i = 0; i < table.length - 1; i ++) {
     
       tmpPasswd.append(String.valueOf(table[i]) + ".");     
     }
     
     tmpPasswd.append(String.valueOf(table[i]));
               
     encPasswd = tmpPasswd.toString();

     return encPasswd;
  }
  
}