//=============================================================================
//
// class createTables
//
// Created:	       	07/20/99
// Author:			Hyun Kim
// Description:     create necessay tables into the database
//
//=============================================================================

package webwisdom.tango.config;

import java.util.*;
import java.lang.*;
import java.util.Properties;
//import java.sql.*;              // for oracle/unix platform and for MS Access/WinNT platform
//import sun.jdbc.odbc.*;         // for MS Access/WinNT platform
//import oracle.jdbc.driver.*;  // for oracle/unix platform
import jdbc.sql.*;            // for oracle/WinNT platform
import oracle.jdbc.*;         // for oracle/WinNT platform

public class createTables {
  
 	private Connection conn;
  
	public void create() throws Exception {

		PreparedStatement pstmt;
		String command = "CREATE TABLE TypesTable ( " +
		                 "type VARCHAR(32) CONSTRAINT pk_TypesTable PRIMARY KEY )";
		String command2 = "CREATE TABLE ObjectsTable ( " +
		                  "type VARCHAR(32) CONSTRAINT ref_ObjectsTable_type REFERENCES TypesTable(type),  " +
	                      "name VARCHAR(32) CONSTRAINT nn_ObjectsTable_name NOT NULL, " +
	                      "CONSTRAINT pk_ObjectsTable PRIMARY KEY (type, name) )";
		String command3 = "CREATE TABLE ObjectDataTable ( " +
	                      "type_name VARCHAR(64) CONSTRAINT nn_ObjectDataTable_type_name NOT NULL, " +
	                      "keyname VARCHAR(255) CONSTRAINT nn_ObjectDataTable_keyname NOT NULL, " +
	                      "keyvalue VARCHAR(255) CONSTRAINT nn_ObjectDataTable_keyvalue NOT NULL, " +
	                      "CONSTRAINT pk_ObjectDataTable PRIMARY KEY (type_name, keyname) )";

		pstmt = conn.prepareStatement(command);
		pstmt.executeUpdate();
		pstmt.close();

		pstmt = conn.prepareStatement(command2);
		pstmt.executeUpdate();
		pstmt.close();

		pstmt = conn.prepareStatement(command3);
		pstmt.executeUpdate();
		pstmt.close();
	}

    public void open(String id, String pwd, String url) throws Exception {
        
		//DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());          // for oracle/unix platform
		DriverManager.registerDriver(new oracle.jdbc.dnlddriver.OracleDriver());      // for oracle/WinNT platform
		//DriverManager.registerDriver(new sun.jdbc.odbc.JdbcOdbcDriver());          // for MS Access/WinNT platform
      	conn = DriverManager.getConnection(url, id, pwd);
		conn.setAutoCommit(false);
    }
    
    public void close() {
        
    	try {

			if (conn != null) {

				conn.commit();
				conn.setAutoCommit(true);
   		   		conn.close();

			} else {

				throw new SQLException("Not connected to database");
			}

    	} catch (Exception e) {

			e.printStackTrace();
		}
    }
}

