//=============================================================================
//
// interface dataAccess
//
// Created:	       	07/20/99
// Author:			Hyun Kim
// Description:     interface for the protocol-specific implementation
//
//=============================================================================

package webwisdom.tango.config;

import java.util.*;

public interface dataAccess {

	public void open(String protocol, String location, String id, String pwd) throws Exception;
	public void update();
	public void update(String location);
	public void close();

	public String getValue(String type, String name, String key);
	public void setValue(String type, String name, String key, String value) throws Exception;
	public void removeKey(String type, String name, String key) throws Exception;

	public Enumeration getObjects(String type);
	public Enumeration getObjectKeys(String type, String name);
	public void addObject(String type, String name) throws Exception;
	public void removeObject(String type, String name) throws Exception;
	
	public Enumeration getTypes();  // return all types of stored objects

}

