//=============================================================================
//
// class dataModule
//
// Created:	       	07/20/99
// Author:			Hyun Kim
// Description:     general class for accessing data through different protocols
//
//=============================================================================

package webwisdom.tango.config;

import java.io.*;
import java.util.*;

public class dataModule {

	dataAccess internalModule = null;

	public void open(String protocol, String location, String id, String pwd) throws Exception {

		internalModule = ModuleFactory.createModule(protocol);

		if (internalModule != null) {  

			internalModule.open(protocol, location, id, pwd);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}



	public void close() {

		if (internalModule != null) {  

			internalModule.close();

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}

	public void update() {

		if (internalModule != null) {  

			internalModule.update();

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}

	public void update(String location) {

		if (internalModule != null) {  

			internalModule.update(location);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}
    
	public String getValue(String type, String name, String key) {

		String result = null;

		if (internalModule != null) {  

			result = internalModule.getValue(type, name, key);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}

		return result;
	}


	public Enumeration getObjects(String type) {

		Enumeration result = null;
		
		if (internalModule != null) {  

			result = internalModule.getObjects(type);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}

		return result;
	}


	public void addObject(String type, String name) throws Exception {

		if (internalModule != null) {   

			internalModule.addObject(type, name);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}


	public void removeObject(String type, String name) throws Exception {

		if (internalModule != null) {  

			internalModule.removeObject(type, name);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}


	public Enumeration getObjectKeys(String type, String name) {

		Enumeration result = null;

		if (internalModule != null) { 

			result = internalModule.getObjectKeys(type, name);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}

		return result;
	}


	public void setValue(String type, String name, String key, String value) throws Exception {

		if (internalModule != null) {  
	
			internalModule.setValue(type, name, key, value);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}


	public void removeKey(String type, String name, String key) throws Exception {

		if (internalModule != null) {  

			internalModule.removeKey(type, name, key);

		} else {
	
			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}
	
	public Enumeration getTypes() {
	    
		Enumeration result = null;	    

		if (internalModule != null) {  

			result = internalModule.getTypes();

		} else {
	
			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
		
		return result;
	}
}



