
//=============================================================================
//
// class fileModule
//
// Created:	       	07/20/99
// Author:			Hyun Kim
// Description:     specific implemetation for accessing data in the file
//
//=============================================================================

package webwisdom.tango.config;

import java.io.*;
import java.util.*;
import java.lang.*;

import com.ibm.xml.parser.*;
import org.w3c.dom.*;

public class fileModule implements dataAccess {

    private File FileLocation;
    private InputStream inStream;
    private TXDocument doc;
    private Element root;
    private String tmp_filename = null;
    
    public void open(String protocol, String location, String id, String pwd) throws Exception {
        
        FileLocation = new File(location);
        tmp_filename = location;
                
        if (!FileLocation.exists()) {
            
			throw new java.io.FileNotFoundException(location);
			
        } else {
            
            inStream = new FileInputStream(location);
            
            // make the DOM tree, of which root is doc
            
            doc = new Parser(location).readStream(inStream);
            root = (Element)doc.getDocumentElement();
            
            // close the input stream
            
            inStream.close();
        }
    }
    
    public void close() {
        
    }
    
    public void update() {
        
        String charset = "ISO-8859-1";      // MIME charset name
        String jencode = MIME2Java.convert(charset);
        PrintWriter pw;
        
        try {
            
            pw = new PrintWriter(new BufferedWriter(new FileWriter(tmp_filename)));
            
        } catch (IOException e) {
            
            e.printStackTrace();
            return;
        }
        
        doc.setEncoding(charset);
        
        try {
            
            // print DOM tree in XML format using the specified encoding
            
            doc.printWithFormat(pw, jencode);
            
        } catch (IOException e) {
            
            e.printStackTrace();
        }
                
        // close the output stream
        
        pw.close();
    }

    public void update(String location) {
        
        String charset = "ISO-8859-1";      // MIME charset name
        String jencode = MIME2Java.convert(charset);
        PrintWriter pw;
        
        try {
            
            pw = new PrintWriter(new BufferedWriter(new FileWriter(location)));
            
        } catch (IOException e) {
            
            e.printStackTrace();
            return;
        }
        
        doc.setEncoding(charset);
        
        try {
            
            // print DOM tree in XML format using the specified encoding
            
            doc.printWithFormat(pw, jencode);
            
        } catch (IOException e) {
            
            e.printStackTrace();
        }
                
        // close the output stream
        
        pw.close();
    }

    public Enumeration getTypes() {
        
        Vector result = new Vector(20);

        if (root.hasChildNodes()) {
            
            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("object");
            
            for (int i = 0; i < objects.getLength(); i++) {
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    String ObjType = ((Element)objects.item(i)).getAttribute("type");
                    
                    if (!result.contains(ObjType)) {
                        
                        result.addElement(ObjType);
                    }
                }
            }
        }

        return result.elements();
    }

    public String getValue(String type, String name, String key) {
          
        if (root.hasChildNodes()) {

            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("name");
            
            for (int i = 0; i < objects.getLength(); i++) {
           
                String ObjName = null;
                Node ObjNode = objects.item(i).getParentNode();
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE && ((Element)ObjNode).getAttribute("type").equals(type)) {
                    
                    // read the object name if the object has the specified type attribute
                    
                    NodeList ObjNameList = objects.item(i).getChildNodes();
                    
                    for (int j = 0; j < ObjNameList.getLength(); j++) {
                        
                        if (ObjNameList.item(j).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                            ObjName = ((CDATASection)ObjNameList.item(j)).getData();
                        }
                    }
                }
                
                if (ObjName != null && ObjName.equals(name)) {
                    
                    // if the object has the given name
                    
                    NodeList keys = ObjNode.getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        String keyname = keys.item(j).getNodeName().toLowerCase();
                        
                        if (keyname.equals(key.toLowerCase())) {
                            
                            NodeList values = keys.item(j).getChildNodes();
                            
                            for (int k = 0; k < values.getLength(); k++) {
                                
                                if (values.item(k).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                                    return ((CDATASection)values.item(k)).getData();
                                }
                            }
                        } 
                    }
                }
            }
        }
                     
        return null;
    }

    public Enumeration getObjects(String type) {
        
        Vector result = new Vector(20);

        if (root.hasChildNodes()) {
            
            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("name");
            
            for (int i = 0; i < objects.getLength(); i++) {
                
                Element ObjType = (Element) objects.item(i).getParentNode();
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE && ObjType.getAttribute("type").equals(type)) {

                    // if the object has the specified type attribute
                    
                    NodeList ObjNameList = objects.item(i).getChildNodes();
                    
                    for (int j = 0; j < ObjNameList.getLength(); j++) {
                        
                        if (ObjNameList.item(j).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                            result.addElement(((CDATASection)ObjNameList.item(j)).getData());
                        }
                    }
                }
            }
        }

        return result.elements();
    }
    
    public void addObject(String type, String name) throws Exception {

        // make the new object with the specified type attribute
        
        TXElement NewObj = (TXElement) doc.createElement("object");
        TXElement NewObjName = (TXElement) doc.createElement("name");
        NewObjName.appendChild(doc.createCDATASection(name));
        NewObj.setAttribute("type", type);
        NewObj.appendChild(NewObjName);
        
        if (root.hasChildNodes()) {
            
            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("name");
            
            for (int i = 0; i < objects.getLength(); i++) {
                
                String ObjName = null;
                Node ObjNode = objects.item(i).getParentNode();
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE && ((Element)ObjNode).getAttribute("type").equals(type)) {

                    // read the object name if the object has the specified type attribute
                    
                    NodeList ObjNameList = objects.item(i).getChildNodes();
                    
                    for (int j = 0; j < ObjNameList.getLength(); j++) {
                        
                        if (ObjNameList.item(j).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                            ObjName = ((CDATASection)ObjNameList.item(j)).getData();
                        }
                    }
                }
                
                if (ObjName != null && ObjName.equals(name)) {

                    // remove the old one if the given object exists
                    
                    try {
                            
                        //root.replaceChild(users.item(i).getParentNode(), new_user);
                        //return;
                        root.removeChild(ObjNode);
                            
                    } catch (DOMException e) {
                            
                        e.printStackTrace();
                    }
                }
            }
        }
        
        // add the new object
        
        root.appendChild(NewObj);
    }
    
    public void removeObject(String type, String name) throws Exception {

        if (root.hasChildNodes()) {
            
            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("name");
            
            for (int i = 0; i < objects.getLength(); i++) {
                
                String ObjName = null;
                Node ObjNode = objects.item(i).getParentNode();
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE && ((Element)ObjNode).getAttribute("type").equals(type)) {

                    // read the object name if the object has the specified type attribute
                    
                    NodeList ObjNameList = objects.item(i).getChildNodes();
                    
                    for (int j = 0; j < ObjNameList.getLength(); j++) {
                        
                        if (ObjNameList.item(j).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                            ObjName = ((CDATASection)ObjNameList.item(j)).getData();
                        }
                    }
                }
                
                if (ObjName != null && ObjName.equals(name)) {
                    
                    // remove it if the object with the given name exists
                    
                    try {
                            
                        root.removeChild(ObjNode);
                        return;
                            
                    } catch (DOMException e) {
                            
                        e.printStackTrace();
                    }
                }
            }
        }
    }    
    
    public Enumeration getObjectKeys(String type, String name) {
        
        Vector result = new Vector(20);

        if (root.hasChildNodes()) {

            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("name");
            
            for (int i = 0; i < objects.getLength(); i++) {
           
                String ObjName = null;
                Node ObjNode = objects.item(i).getParentNode();
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE && ((Element)ObjNode).getAttribute("type").equals(type)) {
                    
                    // read the object name if the object has the specified type attribute
                    
                    NodeList ObjNameList = objects.item(i).getChildNodes();
                    
                    for (int j = 0; j < ObjNameList.getLength(); j++) {
                        
                        if (ObjNameList.item(j).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                            ObjName = ((CDATASection)ObjNameList.item(j)).getData();
                        }
                    }
                }
                
                if (ObjName != null && ObjName.equals(name)) {
                    
                    // retrieve all keys if the object with the given name exists
                    
                    NodeList keys = ObjNode.getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        if (keys.item(j).getNodeType() == Node.ELEMENT_NODE) {
                            
                            result.addElement(keys.item(j).getNodeName().toLowerCase());
                        }
                    }
                    
                    return result.elements();
                }
            }
        }
        
        return null;
    }
    
    public void setValue(String type, String name, String key, String value) throws Exception {

        if (root.hasChildNodes()) {

            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("name");
            
            for (int i = 0; i < objects.getLength(); i++) {
           
                String ObjName = null;
                Node ObjNode = objects.item(i).getParentNode();
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE && ((Element)ObjNode).getAttribute("type").equals(type)) {
                    
                    // read the object name if the object has the specified type attribute
                    
                    NodeList ObjNameList = objects.item(i).getChildNodes();
                    
                    for (int j = 0; j < ObjNameList.getLength(); j++) {
                        
                        if (ObjNameList.item(j).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                            ObjName = ((CDATASection)ObjNameList.item(j)).getData();
                        }
                    }
                }
                
                if (ObjName != null && ObjName.equals(name)) {

                    NodeList keys = ObjNode.getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        String keyname = keys.item(j).getNodeName().toLowerCase();
                        
                        if (keyname.equals(key.toLowerCase())) {
                            
                            NodeList values = keys.item(j).getChildNodes();
                            
                            for (int k = 0; k < values.getLength(); k++) {

                                if (values.item(k).getNodeType() == Node.CDATA_SECTION_NODE) {
                                                            
                                    try {
                                
                                        // modify the value if the given key exists
                                        
                                        ((CDATASection)values.item(k)).setData(value);
                                        return;
                                    
                                    } catch (DOMException e) {
                                    
                                        e.printStackTrace();
                                    }
                                }
                            }
                        } 
                    }
                    
                    // create the new key unless the object has the given key
                            
                    TXElement NewKey = (TXElement) doc.createElement(key);
                    NewKey.appendChild(doc.createCDATASection(value));
                    ObjNode.appendChild(NewKey);
                    return;
                }
            }
        }
    }
    
    public void removeKey(String type, String name, String key) throws Exception {

        if (root.hasChildNodes()) {

            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("name");
            
            for (int i = 0; i < objects.getLength(); i++) {
           
                String ObjName = null;
                Node ObjNode = objects.item(i).getParentNode();
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE && ((Element)ObjNode).getAttribute("type").equals(type)) {

                    // read the object name if the object has the specified type attribute
                    
                    NodeList ObjNameList = objects.item(i).getChildNodes();
                    
                    for (int j = 0; j < ObjNameList.getLength(); j++) {
                        
                        if (ObjNameList.item(j).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                            ObjName = ((CDATASection)ObjNameList.item(j)).getData();
                        }
                    }
                }
                
                if (ObjName != null && ObjName.equals(name)) {
                    
                    NodeList keys = ObjNode.getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        if (keys.item(j).getNodeName().toLowerCase().equals(key.toLowerCase())) {
                            
                            // remove the key and it value if the given key exists
                            
                            ObjNode.removeChild(keys.item(j));
                        }
                    }
                    
                    return;
                }
            }
        }
    }    
   
}


