//=============================================================================
//
// class httpModule
//
// Created:	       	07/20/99
// Author:			Hyun Kim
// Description:     specific implementation for accessing data in the web server
//
//=============================================================================

package webwisdom.tango.config;

import java.util.*;
import java.lang.*;
import java.net.*;
import java.io.*;

import com.ibm.xml.parser.*;
import org.w3c.dom.*;

public class httpModule implements dataAccess {

    private TXDocument doc;
    private Element root;

	public void open(String protocol, String location, String id, String pwd) throws Exception {
	    
	    // connect to the http server
	    
		URL my_url = new URL(location);
		URLConnection url_conn = my_url.openConnection();
		InputStream inStream = url_conn.getInputStream();
		
        // make the DOM tree, of which root is doc
            
        doc = new Parser(location).readStream(inStream);
        root = (Element)doc.getDocumentElement();
            
        // close the input stream
            
        inStream.close();
	}

	public void close() {
	    
	}

	public void update() {
	    
	}
	
	public void update(String location) {
	    
	}

    public Enumeration getTypes() {
        
        Vector result = new Vector(20);

        if (root.hasChildNodes()) {
            
            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("object");
            
            for (int i = 0; i < objects.getLength(); i++) {
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE) {
                    
                    String ObjType = ((Element)objects.item(i)).getAttribute("type");
                    
                    if (!result.contains(ObjType)) {
                        
                        result.addElement(ObjType);
                    }
                }
            }
        }

        return result.elements();
    }
	
    public String getValue(String type, String name, String key) {
          
        if (root.hasChildNodes()) {

            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("name");
            
            for (int i = 0; i < objects.getLength(); i++) {
           
                String ObjName = null;
                Node ObjNode = objects.item(i).getParentNode();
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE && ((Element)ObjNode).getAttribute("type").equals(type)) {
                    
                    // read the object name if the object has the specified type attribute
                    
                    NodeList ObjNameList = objects.item(i).getChildNodes();
                    
                    for (int j = 0; j < ObjNameList.getLength(); j++) {
                        
                        if (ObjNameList.item(j).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                            ObjName = ((CDATASection)ObjNameList.item(j)).getData();
                        }
                    }
                }
                
                if (ObjName != null && ObjName.equals(name)) {
                    
                    // if the object has the given name
                    
                    NodeList keys = ObjNode.getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        String keyname = keys.item(j).getNodeName().toLowerCase();
                        
                        if (keyname.equals(key.toLowerCase())) {
                            
                            NodeList values = keys.item(j).getChildNodes();
                            
                            for (int k = 0; k < values.getLength(); k++) {
                                
                                if (values.item(k).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                                    return ((CDATASection)values.item(k)).getData();
                                }
                            }
                        } 
                    }
                }
            }
        }
                     
        return null;
    }

	public void setValue(String type, String name, String key, String value) throws Exception {

		throw new IllegalModificationException();
	}

	public void removeKey(String type, String name, String key) throws Exception {

		throw new IllegalModificationException();
	}

    public Enumeration getObjects(String type) {
        
        Vector result = new Vector(20);

        if (root.hasChildNodes()) {
            
            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("name");
            
            for (int i = 0; i < objects.getLength(); i++) {
                
                Element ObjType = (Element) objects.item(i).getParentNode();
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE && ObjType.getAttribute("type").equals(type)) {

                    // if the object has the specified type attribute
                    
                    NodeList ObjNameList = objects.item(i).getChildNodes();
                    
                    for (int j = 0; j < ObjNameList.getLength(); j++) {
                        
                        if (ObjNameList.item(j).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                            result.addElement(((CDATASection)ObjNameList.item(j)).getData());
                        }
                    }
                }
            }
        }

        return result.elements();
    }

    public Enumeration getObjectKeys(String type, String name) {
        
        Vector result = new Vector(20);

        if (root.hasChildNodes()) {

            // retrieve all objects
            
            NodeList objects = root.getElementsByTagName("name");
            
            for (int i = 0; i < objects.getLength(); i++) {
           
                String ObjName = null;
                Node ObjNode = objects.item(i).getParentNode();
                
                if (objects.item(i).getNodeType() == Node.ELEMENT_NODE && ((Element)ObjNode).getAttribute("type").equals(type)) {
                    
                    // read the object name if the object has the specified type attribute
                    
                    NodeList ObjNameList = objects.item(i).getChildNodes();
                    
                    for (int j = 0; j < ObjNameList.getLength(); j++) {
                        
                        if (ObjNameList.item(j).getNodeType() == Node.CDATA_SECTION_NODE) {
                            
                            ObjName = ((CDATASection)ObjNameList.item(j)).getData();
                        }
                    }
                }
                
                if (ObjName != null && ObjName.equals(name)) {
                    
                    // retrieve all keys if the object with the given name exists
                    
                    NodeList keys = ObjNode.getChildNodes();
                    
                    for (int j = 0; j < keys.getLength(); j++) {
                        
                        if (keys.item(j).getNodeType() == Node.ELEMENT_NODE) {
                            
                            result.addElement(keys.item(j).getNodeName().toLowerCase());
                        }
                    }
                    
                    return result.elements();
                }
            }
        }
        
        return null;
    }

	public void addObject(String type, String name) throws Exception {

		throw new IllegalModificationException();
	}
	
	public void removeObject(String type, String name) throws Exception {

		throw new IllegalModificationException();
	}

}

