//=============================================================================
//
// class jdbcModule
//
// Created:	       	07/20/99
// Author:			Hyun Kim
// Description:     specific implementation for accessing data in the database
//
//=============================================================================

package webwisdom.tango.config;

import java.util.*;
import java.lang.*;
import java.util.Properties;
//import java.sql.*;              // for oracle/unix platform and for MS Access/WinNT platform
//import sun.jdbc.odbc.*;         // for MS Access/WinNT platform
//import oracle.jdbc.driver.*;    // for oracle/unix platform
import jdbc.sql.*;         //    for oracle/WinNT platform
import oracle.jdbc.*;         // for oracle/WinNT platform

public class jdbcModule implements dataAccess {
  
 	private Connection conn;
  
	public void open(String protocol, String location, String id, String pwd) throws Exception {

	    // connect to the database

		//DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());          // for oracle/unix platform
		DriverManager.registerDriver(new oracle.jdbc.dnlddriver.OracleDriver());      // for oracle/WinNT platform
	    //DriverManager.registerDriver(new sun.jdbc.odbc.JdbcOdbcDriver());          // for MS Access/WinNT platform
      	conn = DriverManager.getConnection(location, id, pwd);
      	
      	if ( conn != null) {
      	    
		    conn.setAutoCommit(false);
		    
		} else {
		    
		    throw new SQLException("Connection Failure");
		}
	}

  	public void update() {

    	try {
    	    
            // commit all changes and then disconnect from the database

			if (conn != null) {

				conn.commit();
				conn.setAutoCommit(true);
   		   		conn.close();

			} else {

				throw new SQLException("Not connected to database");
			}

    	} catch (Exception e) {

			e.printStackTrace();
		}
  	}

  	public void update(String location) {

    	try {

            // commit all changes and then disconnect from the database

			if (conn != null) {

				conn.commit();
				conn.setAutoCommit(true);
   		   		conn.close();

			} else {

				throw new SQLException("Not connected to database");
			}

    	} catch (Exception e) {

			e.printStackTrace();
		}
  	}

  	public void close() {

    	try {

        	// disconnect from the database without commit

			if (conn != null) {

				conn.rollback();
				conn.setAutoCommit(true);
				conn.close();

			} else {

				throw new SQLException("Not connected to database");
			}

		} catch (Exception e)  {

			e.printStackTrace();
		}
    }

	public String getValue(String type, String name, String key) { 
	
	 	String queryname = type + "_" + name;
	 	String command = "SELECT keyvalue FROM ObjectDataTable WHERE type_name = '" + queryname + "' AND keyname = '" + key.toLowerCase() + "'";
		String valueOfKey = null;
	  	PreparedStatement pstmt;
	  	ResultSet rs;

		try {

			if (conn != null) {

	  			pstmt = conn.prepareStatement(command);
	  			rs = pstmt.executeQuery();

	  			if (rs.next()) {

			  		valueOfKey = rs.getString(1);
				}

	  			pstmt.close();

			} else {

				throw new SQLException("Not connected to database");
			}

		} catch (SQLException e) {

	  		e.printStackTrace();
		}

		return valueOfKey;
	}

    public Enumeration getTypes() {
        
		ResultSet rs;
		Vector v = new Vector(20);
		PreparedStatement pstmt;
		String command = "SELECT type FROM TypesTable";
		
		try {

			if (conn != null) {

		  		pstmt = conn.prepareStatement(command);
				rs = pstmt.executeQuery();

				while ( rs.next() ) {

					v.addElement(rs.getString(1));
				}

				pstmt.close();

			} else {

				throw new SQLException("Not connected to databse");
			}

		} catch (SQLException e) {

			e.printStackTrace();
		}

		return v.elements();
    }

	public Enumeration getObjects(String type) {

		ResultSet rs;
		Vector v = new Vector(20);
		PreparedStatement pstmt;
		String command = "SELECT name FROM ObjectsTable WHERE type = '" + type + "'";
		
		try {

			if (conn != null) {

		  		pstmt = conn.prepareStatement(command);
				rs = pstmt.executeQuery();

				while ( rs.next() ) {

					v.addElement(rs.getString(1));
				}

				pstmt.close();

			} else {

				throw new SQLException("Not connected to databse");
			}

		} catch (SQLException e) {

			e.printStackTrace();
		}

		return v.elements();
	}

	public Enumeration getObjectKeys(String type, String name) {

		ResultSet rs;
		PreparedStatement pstmt;
		Vector v = new Vector(20);
		String queryname = type + "_" + name;
		String command = "SELECT keyname FROM ObjectDataTable WHERE type_name = '" + queryname + "'"; 

		try {

			if (conn != null) {

				pstmt = conn.prepareStatement(command);
				rs = pstmt.executeQuery();

				while (rs.next()) {

					v.addElement(rs.getString(1));
				} 

				pstmt.close();

			} else {

				throw new SQLException("Not connected to database");
			}

		} catch (SQLException e) {

			e.printStackTrace();
		}

		return v.elements();
	}

	public void addObject(String type, String name) throws Exception {

		PreparedStatement pstmt;
		String command = "INSERT INTO TypesTable (type) VALUES ('" + type + "')";
		String command2 = "INSERT INTO ObjectsTable (type, name) VALUES ('" + type + "', '" + name + "')";
		String queryname = type + "_" + name;
		String command3 = "INSERT INTO ObjectDataTable (type_name, keyname, keyvalue) VALUES ('" + queryname + "', 'name', '" + name + "')";

		if (containsObject(type, name)) {
	
			// if the object with the given name already exists

			removeObject(type, name);
		}
		
		try {

			if (conn != null) {

                // add the given type to TypesTable
                
				pstmt = conn.prepareStatement(command);
				pstmt.executeUpdate();
				pstmt.close();

                // add the new object to ObjectsTable and ObjectDataTable
                
				pstmt = conn.prepareStatement(command2);
				pstmt.executeUpdate();
				pstmt.close();
				
				pstmt = conn.prepareStatement(command3);
				pstmt.executeUpdate();
				pstmt.close();

			} else {

				throw new SQLException("Not connected to database");
			}

		} catch (SQLException e) {
		    
		    // if the given type already exists in TypesTable
		        
			pstmt = conn.prepareStatement(command2);
			pstmt.executeUpdate();
			pstmt.close();
				
			pstmt = conn.prepareStatement(command3);
			pstmt.executeUpdate();
			pstmt.close();
		}
	}

	public void removeObject(String type, String name) throws Exception {

		PreparedStatement pstmt, pstmt2;
		String queryname = type + "_" + name;
		String command = "DELETE FROM ObjectDataTable WHERE type_name = '" + queryname + "'"; 
		String command2 = "DELETE FROM ObjectsTable WHERE type = '" + type + "' AND name = '" + name + "'";
		String command3 = "DELETE FROM TypesTable WHERE type = '" + type + "'";
		
		if (conn != null) {

			pstmt = conn.prepareStatement(command);
			pstmt.executeUpdate();
			pstmt.close();

			pstmt = conn.prepareStatement(command2);
			pstmt.executeUpdate();
			pstmt.close();
				
			pstmt = conn.prepareStatement("SELECT type FROM ObjectsTable WHERE type = '" + type + "'");
			ResultSet rs = pstmt.executeQuery();
			if (!rs.next()) {
			    
			    // if there is no object with the given type, remove that type from TypesTable
			    
	    		pstmt2 = conn.prepareStatement(command3);
		   		pstmt2.executeUpdate();
		    	pstmt2.close();				    
			}
			pstmt.close();

		} else {

			throw new SQLException("Not connected to database");
		}
	}

	public void removeKey(String type, String name, String key) throws Exception {

		PreparedStatement pstmt;
		String queryname = type + "_" + name;
		String command = "DELETE FROM ObjectDataTable WHERE type_name = '" + queryname + "' AND keyname = '" + key.toLowerCase() + "'";

	    if (conn != null) {

			pstmt = conn.prepareStatement(command);
			pstmt.executeUpdate();
			pstmt.close();

		} else {

			throw new SQLException("Not connected to database");
		}
	}

	public void setValue(String type, String name, String key, String value) throws Exception {

		PreparedStatement pstmt;
		String queryname = type + "_" + name;
		String command = "UPDATE ObjectDataTable SET keyvalue = '" + value + "' WHERE type_name = '" 
		                + queryname + "' AND keyname = '" + key.toLowerCase() + "'";
		int row;

		if (!containsObject(type, name)) {

			// do nothing if the object with the specified type and name does not exist

			return;
		}

		try {

			if (conn != null) {

				pstmt = conn.prepareStatement(command);
				row = pstmt.executeUpdate();
				pstmt.close();

				if (row < 1) {

                    // if the key does not exist, throw an exception in order to add the key
                    
					throw new SQLException();
				}

			} else {

				throw new SQLException("Not connected to database");
			}

		} catch (SQLException e) {

			// if the key does not exist, it is created

			addKey(queryname, key, value);
		}
	}


/*

	private void addKey(String name, String key, String value)

	: Create the new key and its value for the given object.

*/

	private void addKey(String name, String key, String value) throws Exception {

		PreparedStatement pstmt;
		String command = "INSERT INTO ObjectDataTable (type_name, keyname, keyvalue) " + "VALUES ('" 
		                + name + "','" + key.toLowerCase() + "','" + value + "')";

		if (conn != null) {

			pstmt = conn.prepareStatement(command);
			pstmt.executeUpdate();
			pstmt.close();

		} else {

			throw new SQLException("Not connected to database");
		}
	}


/*

	private boolean containsObject(String type, String name) 

	: Check if the object with the given name exists or not.

*/

	private boolean containsObject(String type, String name) {

		PreparedStatement pstmt;
		String command = "SELECT name FROM ObjectsTable WHERE type = '" + type + "' AND name = '" + name + "'";
		boolean result = false;
		ResultSet rs;

		try {

			if (conn != null) {

				pstmt = conn.prepareStatement(command);
				rs = pstmt.executeQuery();
				if (rs.next()) {

					result = true;
		        }
				pstmt.close();

			} else {

				throw new SQLException("Not connected to database");
			}

		} catch (SQLException e) {
	
			e.printStackTrace();
		}
		
		return result;
	}

}

