/***************************************************************************
  FILE: CAppAnswerEventMessage.java, TomaszJurga-10Dec96
  PURPOSE: main interface
  $Id: CAppAnswerEventMessage.java,v 1.7 1999/07/26 17:01:53 toma Exp $
  Component: Plugin
***************************************************************************/


package webwisdom.tango.messages;


import webwisdom.tango.messages.AppEventMessage;
import webwisdom.tango.consts.*;
import java.util.Vector;
import java.util.Hashtable;
import java.io.*;


public class CAppAnswerEventMessage extends AppEventMessage
{
    private static final String CL="CaAnswer";


    public CAppAnswerEventMessage(byte[] tab)
    {
      super(Const.CONTROL,tab);
    }// CAppAnswerEventMessage _____________________________________________


    private byte getSubType()
    {
      return super.getData()[0];
    }// getSubType _________________________________________________________


    public byte getAnswerType()
    {
      return getSubType();
    }// getAnswerType ______________________________________________________


    public byte[] getAnswerData()
    {
      //throw new RuntimeException("deprecated method");
      //System.out.println(CL+".getData(): this is a big mess");
      //return super.getData();
      //throw new RuntimeException("deprecated method");
//       if(getSubType()==CAConsts.DATAPASS)
//       {
// 	throw new RuntimeException("deprecated method");
// // 	ByteArrayOutputStream datapass = new ByteArrayOutputStream();
// // 	byte[] data = super.getData();
// // 	int len = super.getLen();
// // 	int appname_len = data[1];
// // 	datapass.write(data,appname_len+2,len-appname_len-2);
// // 	return datapass.toByteArray();
//       }
//       else
//       {
	//System.out.println(CL+".getData(): this is a bigmess");
	try
	{
	  byte[] tmp = super.getData();
	  byte[] res = new byte[tmp.length-1];
	  System.arraycopy(tmp,1,res,0,tmp.length-1);
	  return res;
	} 
	catch(Exception e)
	{
	  e.printStackTrace();
	  return null;
	}
//       }
    }// getAnswerData ______________________________________________________


    public boolean isMaster()
    {
      if(getSubType()!=CAConsts.ISMASTER)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.ISMASTER));


      return super.getData()[1]==CAConsts.YES;
    }// isMaster ___________________________________________________________


    public String getMastername()
    {
      if(getSubType()!=CAConsts.MASTERNAME)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.MASTERNAME));


      return new String(super.getData(),0,1,getLen()-1);
    }// getMastername ______________________________________________________


    public String getUsername()
    {
      if(getSubType()!=CAConsts.USERNAME)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.USERNAME));


      return new String(super.getData(),0,1,getLen()-1);
    }// getUsername ________________________________________________________


    public Vector getParticipants()
    {
      if(getSubType()!=CAConsts.PARTICIPANTS)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.PARTICIPANTS));


      return processData();
    }// getParticipants ____________________________________________________


    private Vector processData()
    {
      int len = super.getLen();
      byte[] data = super.getData();
      
      int index=1;
      Vector vect = new Vector();
      
      while (index<len)
      {
	int strlen = (int) data[index];
	index++;
	String pom = new String(data,0,index,strlen);
	vect.addElement(pom);
	index+=strlen; 
      }
      
      return vect;
    }// processData ________________________________________________________


    public Hashtable getPartipuids()
    {
      if(getSubType()!=CAConsts.PARTIPUID)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.PARTIPUID));


      Hashtable partipuids=new Hashtable();
      byte b[]=getAnswerData();
      ByteArrayInputStream bais=new ByteArrayInputStream(b);
      DataInputStream dis=new DataInputStream(bais);
      try
      {
	while(dis.available()>0)
	{
	  Integer i=new Integer(dis.readInt());
	  String s=dis.readUTF();
	  //System.out.println("\t("+i+","+s+")");
	  partipuids.put(s,i);
	}
      }
      catch(IOException e)
      {
	System.err.println(CL+".getPartipuids("+this+")"+
			   ": error processing PARTIPUID message!: "+e);
	e.printStackTrace();
      }
      return partipuids;
    }// getPartipuids ______________________________________________________


    public Vector getLocalApps()
    {
      if(getSubType()!=CAConsts.LOCALAPPS)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.LOCALAPPS));


      Vector localapps=new Vector();
      byte b[]=getAnswerData();
      for(int off=1;off<b.length;)
      {
	int sessLen=(int)b[off++];
	String session=new String(b,off,sessLen);
	off+=sessLen;
	//System.out.println("\t["+sessLen+"]"+session);
	localapps.addElement(session);
      }
      return localapps;
    }// getLocalApps _______________________________________________________


    public String getSender()
    {
      if(getSubType()!=CAConsts.DATAPASS)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.DATAPASS));


      byte[] b=getAnswerData();
      int sessLen=(int)b[0];
      String session=new String(b,1,sessLen);
      return session;
    }// getSender __________________________________________________________


    public byte[] getDatapass()
    {
      if(getSubType()!=CAConsts.DATAPASS)
	throw new RuntimeException(CAConsts.toString(getSubType())+"!="+
				   CAConsts.toString(CAConsts.DATAPASS));


      byte[] b=getAnswerData();
      int sessLen=(int)b[0];
      int dataLen=b.length-1-sessLen;
      byte[] data=new byte[dataLen];
      System.arraycopy(b,1+sessLen,data,0,dataLen);
      return data;
    }// getDatapass ________________________________________________________


    public String toString()
    {
      return CL+"@"+hashCode()+"["+CAConsts.toString(getSubType())+"]";
    }// toString ___________________________________________________________


}// CAppAnswerEventMessage /////////////////////////////////////////////////


