
// $Id: WatchNet.java,v 1.1 1999/07/13 21:23:18 beca Exp $
/*
File: AppNet.java
Component: Plugin
Date		Author		Changes
Jun 30 99	Lukasz Beca	Created
*/

package webwisdom.tango.messages;

import java.io.*;
import java.net.*;
import webwisdom.tango.test.Log;


public class WatchNet
{
    private static final String CL="WatchNet";

    Socket s;
    DataInputStream in;
    DataOutputStream out;  

    /**
     *@param sparam socket used to send and receive messages*/
    public WatchNet(Socket sparam) //throws Exception
    {
      s=sparam;
      try
      {
	in=new DataInputStream(s.getInputStream());
	out=new DataOutputStream(s.getOutputStream());
      }
      catch(Exception e)
      {
  Log.err.println(CL+".WatchNet(): "+e, 2);
	//throw new Exception("bad socket");
	System.exit(1);
      }
    }// AppNet _____________________________________________________________


    /**
     *@param m message to be sent
     *@exception IOException*/
    public void send(Message m) throws IOException
    {
      m.send(out);
    }// send _______________________________________________________________


    /**
     *@return received message
     *@exception IOException*/
    public WatcherMessage receive() throws IOException
    {
      //System.out.println(CL+"receive()");
      WatcherMessage result=new WatcherMessage(in);
      //System.out.println(CL+"receive(): typr="+result.getType());
      return result;
    }// receive ____________________________________________________________
 

    /**Waits until application registers
     *@return AID of application*/
    public int getData()
    {
      //System.out.println(CL+".getData()");
      int data;
      try
      {
	data=in.readInt();
      }
      catch(Exception e)
      {
	Log.err.println(CL+".getData(): "+e, 2);
	System.exit(1);
	data=0;
      }
      return data;
    }// getData ____________________________________________________________


    /**Closes streams and connection*/
    public void close()
    {
      //System.out.println(CL+".close()");
      try
      {
	out.flush();
	out.close();
	in.close();
	s.close();
      }
      catch(IOException e)
      {
          Log.err.println(CL+".close(): ignoring exception: "+e, 2);
      }
    }// close ______________________________________________________________


    public String toString()
    {
      return CL+"[socket="+s+"]";
    }// toString __________________________________________________________


}// AppNet /////////////////////////////////////////////////////////////////